Index: /trunk/src/org/expeditee/actions/Misc.java
===================================================================
--- /trunk/src/org/expeditee/actions/Misc.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Misc.java	(revision 1102)
@@ -19,9 +19,4 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
-import java.awt.Desktop;
-import java.awt.Image;
-import java.awt.image.BufferedImage;
-import java.awt.image.VolatileImage;
 import java.io.BufferedReader;
 import java.io.File;
@@ -31,6 +26,4 @@
 import java.io.InputStreamReader;
 import java.lang.reflect.Method;
-import java.net.URI;
-import java.net.URISyntaxException;
 import java.net.URL;
 import java.net.URLClassLoader;
@@ -39,22 +32,20 @@
 import java.util.LinkedList;
 import java.util.List;
-import java.util.Map;
 import java.util.Map.Entry;
-import java.util.Set;
 import java.util.jar.Attributes;
 import java.util.jar.JarFile;
 
-import javax.imageio.ImageIO;
-
+import org.expeditee.core.Colour;
+import org.expeditee.core.Image;
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.gui.AttributeUtils;
-import org.expeditee.gui.Browser;
 import org.expeditee.io.Conversion;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.io.ExpReader;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameKeyboardActions;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.FreeItems;
@@ -63,5 +54,4 @@
 import org.expeditee.gui.Reminders;
 import org.expeditee.gui.TimeKeeper;
-import org.expeditee.importer.FrameDNDTransferHandler;
 import org.expeditee.items.Item;
 import org.expeditee.items.ItemUtils;
@@ -69,5 +59,5 @@
 import org.expeditee.items.Text;
 import org.expeditee.items.XRayable;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
@@ -83,10 +73,8 @@
 import org.nfunk.jep.ParseException;
 
-import com.lowagie.text.Font;
-
 
 
 /**
- * A list of miscellaneous Actions and Actions specific to Expeditee
+ * A list of miscellaneous Actions specific to Expeditee
  * 
  */
@@ -96,6 +84,7 @@
 	 * Causes the system to beep
 	 */
-	public static void beep() {
-		java.awt.Toolkit.getDefaultToolkit().beep();
+	public static void beep()
+	{
+		EcosystemManager.getMiscManager().beep();
 	}
 	
@@ -161,14 +150,9 @@
 	 * Treats a string as a URL and attempts to open it
 	 */
-	public static void openURL(String siteURL){
-		
-		try {
-			URL check = new URL(siteURL);			
-			Desktop.getDesktop().browse(new URI(siteURL));
-			
-		} catch (IOException| URISyntaxException e) {
-		
-			MessageBay.displayMessage("'" + siteURL + "' is not a valid URL");
-		}		
+	public static void openURL(String siteURL)
+	{
+		boolean success = EcosystemManager.getMiscManager().browse(siteURL);
+		
+		if (!success) MessageBay.displayMessage("'" + siteURL + "' is not a valid URL");	
 	}
 	/**
@@ -177,5 +161,5 @@
 	public static void setRestorePoint()
 	{
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		current.change();
 		FrameIO.SaveFrameAsRestore(current, true, true);		
@@ -185,9 +169,9 @@
 	 */
 	public static void display() {
-		FrameGraphics.refresh(false);
+		DisplayController.requestRefresh(false);
 	}
 	
 	public static String getWindowSize() {
-		return Browser.getWindows()[0].getSize().toString();
+		return EcosystemManager.getGraphicsManager().getWindowSize().toString();
 	}
 
@@ -205,5 +189,5 @@
 	 */
 	public static void toggleAudienceMode() {
-		FrameGraphics.ToggleAudienceMode();
+		DisplayController.ToggleAudienceMode();
 	}
 
@@ -212,5 +196,5 @@
 	 */
 	public static void toggleTwinFramesMode() {
-		DisplayIO.ToggleTwinFrames();
+		DisplayController.toggleTwinFrames();
 	}
 
@@ -227,5 +211,5 @@
 			for (String action : actions) {
 				if (!action.equalsIgnoreCase("runitem")) {
-					Actions.PerformAction(DisplayIO.getCurrentFrame(), current,
+					Actions.PerformAction(DisplayController.getCurrentFrame(), current,
 							action);
 				}
@@ -249,8 +233,8 @@
 			String deletedFrameName = FrameIO.DeleteFrame(toDelete);
 			if (deletedFrameName != null) {
-				DisplayIO.Back();
+				DisplayController.Back();
 				// Remove any links on the previous frame to the one being
 				// deleted
-				Frame current = DisplayIO.getCurrentFrame();
+				Frame current = DisplayController.getCurrentFrame();
 				for (Item i : current.getItems())
 					if (i.getLink() != null
@@ -312,5 +296,5 @@
 			// copy the item and switch
 			item = item.copy();
-			item.setPosition(DisplayIO.getMouseX(), FrameMouseActions.getY());
+			item.setPosition(DisplayController.getMousePosition());
 		}
 		return item;
@@ -327,6 +311,6 @@
 		Collection<Item> copies = ItemUtils.CopyItems(items);
 		Item first = items.iterator().next();
-		float deltaX = DisplayIO.getMouseX() - first.getX();
-		float deltaY = FrameMouseActions.getY() - first.getY();
+		float deltaX = DisplayController.getMouseX() - first.getX();
+		float deltaY = DisplayController.getMouseY() - first.getY();
 		for (Item i : copies) {
 			if (i.isVisible())
@@ -334,6 +318,6 @@
 			i.setParent(null);
 		}
-		FrameMouseActions.pickup(copies);
-		FrameGraphics.Repaint();
+		StandardGestureActions.pickup(copies);
+		DisplayController.requestRefresh(true);
 	}
 	
@@ -347,10 +331,10 @@
 	 *            The Color to give the Item.
 	 */
-	public static void SetItemBackgroundColor(Item toChange, Color toUse) {
+	public static void SetItemBackgroundColor(Item toChange, Colour toUse) {
 		if (toChange == null)
 			return;
 
 		toChange.setBackgroundColor(toUse);
-		FrameGraphics.Repaint();
+		DisplayController.requestRefresh(true);
 	}
 
@@ -364,10 +348,10 @@
 	 *            The Color to give the Item.
 	 */
-	public static void SetItemColor(Item toChange, Color toUse) {
+	public static void SetItemColor(Item toChange, Colour toUse) {
 		if (toChange == null)
 			return;
 
 		toChange.setColor(toUse);
-		FrameGraphics.Repaint();
+		DisplayController.requestRefresh(true);
 	}
 
@@ -428,16 +412,16 @@
 	public static void attachStatsToCursor(String itemText) {
 		SessionStats.CreatedText();
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		Item text = current.getStatsTextItem(itemText);
-		FrameMouseActions.pickup(text);
-		FrameGraphics.Repaint();
+		StandardGestureActions.pickup(text);
+		DisplayController.requestRefresh(true);
 	}
 
 	public static void attachTextToCursor(String itemText) {
 		SessionStats.CreatedText();
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		Item text = current.getTextItem(itemText);
-		FrameMouseActions.pickup(text);
-		FrameGraphics.Repaint();
+		StandardGestureActions.pickup(text);
+		DisplayController.requestRefresh(true);
 	}
 	
@@ -494,5 +478,5 @@
 		}
 
-		for (Entry<String, java.awt.Font> entry: Text.FONT_WHEEL_ADDITIONAL_LOOKUP.entrySet()){
+		for (Entry<String, org.expeditee.core.Font> entry: Text.FONT_WHEEL_ADDITIONAL_LOOKUP.entrySet()){
 			
 			String fontName = entry.getKey();
@@ -585,5 +569,5 @@
 	 */
 	public static void jpegFrame() {
-		ImageFrame(DisplayIO.getCurrentFrame().getName(), "JPEG");
+		ImageFrame(DisplayController.getCurrentFrame().getName(), "JPEG");
 	}
 
@@ -610,5 +594,5 @@
 	}
 
-	public static String SaveImage(BufferedImage screen, String format,
+	public static String SaveImage(Image screen, String format,
 			String directory, String fileName) {
 		String suffix = "." + format.toLowerCase();
@@ -633,5 +617,5 @@
 
 			// If the image is successfully written out return the fileName
-			if (ImageIO.write(screen, format, out))
+			if (screen.writeToDisk(format, out))
 				return fileName;
 
@@ -647,21 +631,12 @@
 		Image oldBuffer = frame.getBuffer();
 		frame.setBuffer(null);
-		// Jpeg only works properly with volitile frames
+		// Jpeg only works properly with volatile frames
 		// Png transparency only works with bufferedImage form
-		Image frameBuffer = FrameGraphics.getBuffer(frame, false, format
-				.equalsIgnoreCase("jpeg"));
-		// Make sure overlay stuff doesnt disapear on the frame visible on the
+		Image frameBuffer = FrameGraphics.getFrameImage(frame, null, null, false, format.equalsIgnoreCase("jpeg"));
+		// Make sure overlay stuff doesnt disappear on the frame visible on the
 		// screen
 		frame.setBuffer(oldBuffer);
-		BufferedImage screen = null;
-
-		if (frameBuffer instanceof VolatileImage) {
-			// If its the current frame it will be a volitive image
-			screen = ((VolatileImage) frameBuffer).getSnapshot();
-		} else {
-			assert (frameBuffer instanceof BufferedImage);
-			screen = (BufferedImage) frameBuffer;
-		}
-		return SaveImage(screen, format, directory, frame.getExportFileName());
+		
+		return SaveImage(frameBuffer, format, directory, frame.getExportFileName());
 	}
 
@@ -842,5 +817,5 @@
 		current.setActions(null);
 
-		FrameGraphics.Repaint();
+		DisplayController.requestRefresh(true);
 	}
 
@@ -932,7 +907,7 @@
 				text.setFormula(formulaFullCase);
 				if (text.isFloating()) {
-					text.setPosition(FrameMouseActions.MouseX,
-							FrameMouseActions.MouseY);
-					FrameMouseActions.resetOffset();
+					Point cursorPos = EcosystemManager.getInputManager().getCursorPosition();
+					text.setPosition(cursorPos.x, cursorPos.y);
+					StandardGestureActions.resetOffset();
 				} else {
 					text.getParentOrCurrentFrame().change();
@@ -956,6 +931,6 @@
 	public static void attachToCursor(Item item) {
 		item.setParent(null);
-		FrameMouseActions.pickup(item);
-		FrameGraphics.Repaint();
+		StandardGestureActions.pickup(item);
+		DisplayController.requestRefresh(true);
 	}
 
@@ -965,8 +940,8 @@
 			i.invalidateAll();
 		}
-		FrameMouseActions.pickup(items);
+		StandardGestureActions.pickup(items);
 		// TODO figure out why this isnt repainting stuff immediately
 		// All of text item doesnt repaint until the cursor is moved
-		FrameGraphics.requestRefresh(true);
+		DisplayController.requestRefresh(true);
 	}
 
@@ -980,6 +955,5 @@
 		}
 		try {
-			FrameDNDTransferHandler.getInstance().importFileList(files,
-					FrameMouseActions.getPosition());
+			EcosystemManager.getDragAndDropManager().importFileList(files, EcosystemManager.getInputManager().getCursorPosition());
 		} catch (Exception e) {
 		}
@@ -990,6 +964,5 @@
 		if (file.exists()) {
 			try {
-				FrameDNDTransferHandler.getInstance().importFile(file,
-						FrameMouseActions.getPosition());
+				EcosystemManager.getDragAndDropManager().importFile(file, EcosystemManager.getInputManager().getCursorPosition());
 			} catch (Exception e) {
 				e.printStackTrace();
@@ -1021,11 +994,12 @@
 		}
 
-		float curX = FrameMouseActions.MouseX;
-		float curY = FrameMouseActions.MouseY;
+		Point cursorPos = DisplayController.getMousePosition();
+		float curX = cursorPos.x;
+		float curY = cursorPos.y;
 
 		Collection<Item> newItems = new LinkedList<Item>();
 		Item[] d = new Item[sides];
 		// create dots
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		for (int i = 0; i < d.length; i++) {
 			d[i] = current.createDot();
@@ -1053,5 +1027,5 @@
 		}
 
-		Color newColor = item.getColor();
+		Colour newColor = item.getColor();
 		if (newColor != null) {
 			d[0].setColor(item.getColor());
@@ -1068,5 +1042,5 @@
 
 		ItemUtils.EnclosedCheck(newItems);
-		FrameGraphics.refresh(false);
+		DisplayController.requestRefresh(false);
 
 		return d[0];
@@ -1077,14 +1051,9 @@
 	}
 
-	public static void print(String file) {
-		try {
-			if (Browser._theBrowser.isMinimumVersion6()) {
-				if (Desktop.isDesktopSupported()) {
-					Desktop.getDesktop().print(new File(file));
-				}
-			}
-		} catch (Exception e) {
-			MessageBay.errorMessage("Printing error: " + e.getMessage());
-		}
+	public static void print(String file)
+	{	
+		String errorMessage = EcosystemManager.getMiscManager().print(file);
+		
+		if (errorMessage != null) MessageBay.errorMessage("Printing error: " + errorMessage);
 	}
 
@@ -1129,5 +1098,5 @@
 	 * @throws Exception
 	 */
-	public static void startLoboBrowser(Item text) throws Exception {
+/*	public static void startLoboBrowser(Item text) throws Exception {
 		if (!(text instanceof Text)) {
 			MessageBay.errorMessage("Must be a text item.");
@@ -1154,5 +1123,5 @@
 			
 		FrameMouseActions.pickup(browser.getItems());					// attach browser widget to mouse
-	}
+	}*/
 	
 	/**
@@ -1161,9 +1130,11 @@
 	 * @throws Exception
 	 */
-	public static void startLoboBrowserNewFrame(Item text) throws Exception {
+	public static void startLoboBrowserNewFrame(Item text) throws Exception
+	{
 		if (!(text instanceof Text)) {
 			MessageBay.errorMessage("Must be a text item.");
 			return;
 		}
+		
 		if(text.getLink() != null) {											// text item can't already have a link
 			MessageBay.errorMessage("Text item already has link.");
@@ -1176,12 +1147,11 @@
 		FrameUtils.Parse(frame);
 		
-		for(InteractiveWidget iw : frame.getInteractiveWidgets()) {	// may be other widgets on frame
+		for(Widget iw : frame.getInteractiveWidgets()) {	// may be other widgets on frame
 			if(iw instanceof org.expeditee.items.widgets.Browser) {
 				// Set browser to 'full screen'
-				iw.setSize(-1, -1, -1, -1, Browser._theBrowser.getWidth(), Browser._theBrowser.getHeight() 
-						- MessageBay.MESSAGE_BUFFER_HEIGHT - 80);
+				iw.setSize(-1, -1, -1, -1, DisplayController.getFramePaintArea().getWidth(), DisplayController.getFramePaintArea().getHeight() - 80);
 				
 				// If there is a text item attached to cursor use it as url for browser
-				if(FreeItems.textOnlyAttachedToCursor()) {
+				if (FreeItems.textOnlyAttachedToCursor()) {
 					text.setLink("" + frame.getNumber());
 					((org.expeditee.items.widgets.Browser)iw).navigate(text.getText());
@@ -1190,8 +1160,8 @@
 					((org.expeditee.items.widgets.Browser)iw).navigate("http://www.waikato.ac.nz");
 					Text t = new Text("http://www.waikato.ac.nz");
-					t.setParent(DisplayIO.getCurrentFrame());		// set parent of text source for InteractiveWidget.createWidget()
-					t.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());
+					t.setParent(DisplayController.getCurrentFrame());		// set parent of text source for InteractiveWidget.createWidget()
+					t.setXY(DisplayController.getFloatMouseX(), DisplayController.getFloatMouseY());
 					t.setLink("" + frame.getNumber());				// link url text to new browser frame
-					FrameMouseActions.pickup(t);					// Attach new text link to cursor
+					StandardGestureActions.pickup(t);					// Attach new text link to cursor
 				}
 			}
@@ -1201,5 +1171,6 @@
 	}
 	
-	private static boolean startWidget(String name) throws Exception {
+	private static boolean startWidget(String name) throws Exception
+	{
 		String fullName = Actions.getClassName(name);
 		if(fullName == null) {
@@ -1210,8 +1181,8 @@
 		FreeItems.getInstance().clear();
 		Text wt = new Text("@iw:" + fullName);							// create new text item for browser widget
-		wt.setParent(DisplayIO.getCurrentFrame());						// set parent of text source for InteractiveWidget.createWidget()
-		wt.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());	// move to the mouse cursor
-		InteractiveWidget widget = InteractiveWidget.createWidget(wt);
-		FrameMouseActions.pickup(widget.getItems());
+		wt.setParent(DisplayController.getCurrentFrame());						// set parent of text source for InteractiveWidget.createWidget()
+		wt.setXY(DisplayController.getMouseX(), DisplayController.getMouseY());	// move to the mouse cursor
+		Widget widget = Widget.createWidget(wt);
+		StandardGestureActions.pickup(widget.getItems());
 		
 		return true;
@@ -1223,5 +1194,5 @@
 		}
 		
-		Actions.PerformAction(DisplayIO.getCurrentFrame(), null, command);
+		Actions.PerformAction(DisplayController.getCurrentFrame(), null, command);
 	}
 	
@@ -1241,5 +1212,5 @@
 		if(name == "action" || name == "agent") {
 			if(args.length() > 0) {
-				Actions.PerformAction(DisplayIO.getCurrentFrame(), null, args);
+				Actions.PerformAction(DisplayController.getCurrentFrame(), null, args);
 			} else {
 				MessageBay.displayMessage("Please specify an action/agent name");
@@ -1324,6 +1295,5 @@
 			if (i instanceof WidgetEdge || i instanceof WidgetCorner) {
 				continue;
-			} 
-			else {
+			} else {
 				int new_x = i.getX();
 				int new_y = i.getY();
@@ -1345,8 +1315,8 @@
 			}
 			// update the polygon, otherwise stuff moves but leaves it's outline behind
-			i.updatePolygon();
-		}
-
-		for (InteractiveWidget iw : frame.getInteractiveWidgets()) {
+			i.invalidateBounds();
+		}
+
+		for (Widget iw : frame.getInteractiveWidgets()) {
 
 			int new_x = iw.getX();
@@ -1368,5 +1338,5 @@
 		frame.change();
 		// redraw everything
-		FrameKeyboardActions.Refresh();
+		StandardGestureActions.Refresh();
 	}
 	
@@ -1505,7 +1475,7 @@
     public static void GitPushFrame() {
 
-	FrameKeyboardActions.Save();
-	
-	Frame current = DisplayIO.getCurrentFrame();
+	StandardGestureActions.Save();
+	
+	Frame current = DisplayController.getCurrentFrame();
 	String userName = UserSettings.ProfileName.get();
 
@@ -1544,5 +1514,5 @@
 
     public static void GitPullFrame() {
-	Frame current = DisplayIO.getCurrentFrame();
+	Frame current = DisplayController.getCurrentFrame();
 
 	List<String> cmd_array = new ArrayList<String>();
@@ -1554,5 +1524,5 @@
 	
 	FrameIO.Reload();
-	FrameKeyboardActions.Refresh();
+	StandardGestureActions.Refresh();
     }
 
Index: /trunk/src/org/expeditee/actions/Navigation.java
===================================================================
--- /trunk/src/org/expeditee/actions/Navigation.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Navigation.java	(revision 1102)
@@ -21,5 +21,5 @@
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
@@ -49,9 +49,9 @@
 	 */
 	public static void Back() {
-		DisplayIO.Back();
+		DisplayController.Back();
 	}
 
 	public static void Forward() {
-		DisplayIO.Forward();
+		DisplayController.Forward();
 	}
 
@@ -78,5 +78,5 @@
 	public static void GotoZero() {
 		FrameUtils
-				.DisplayFrame(DisplayIO.getCurrentFrame().getFramesetName() + 0);
+				.DisplayFrame(DisplayController.getCurrentFrame().getFramesetName() + 0);
 	}
 
@@ -96,5 +96,5 @@
 	 */
 	public static void Goto(Integer value) {
-		FrameUtils.DisplayFrame(DisplayIO.getCurrentFrame().getFramesetName()
+		FrameUtils.DisplayFrame(DisplayController.getCurrentFrame().getFramesetName()
 				+ value);
 	}
@@ -132,6 +132,6 @@
 	 */
 	public static void Large() {
-		if (DisplayIO.isTwinFramesOn())
-			DisplayIO.ToggleTwinFrames();
+		if (DisplayController.isTwinFramesOn())
+			DisplayController.toggleTwinFrames();
 	}
 
@@ -188,5 +188,5 @@
 
 	public static void NextChild(Frame source) {
-		String back = DisplayIO.peekFromBackUpStack();
+		String back = DisplayController.peekFromBackUpStack();
 		// if there is no parent frame (i.e. the user is on the home frame) //
 		if (back == null) { // No frame was on the Backup stack
@@ -259,6 +259,6 @@
 	// better to say more explicitly/directly what the mode is!!!!
 	public static void Small() {
-		if (!DisplayIO.isTwinFramesOn())
-			DisplayIO.ToggleTwinFrames();
+		if (!DisplayController.isTwinFramesOn())
+			DisplayController.toggleTwinFrames();
 	}
 
Index: /trunk/src/org/expeditee/actions/Python.java
===================================================================
--- /trunk/src/org/expeditee/actions/Python.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Python.java	(revision 1102)
@@ -19,24 +19,11 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
-import java.util.Collection;
-import java.util.LinkedList;
 import java.util.List;
 
-import javax.script.Bindings;
 import javax.script.Invocable;
-import javax.script.ScriptContext;
-import javax.script.ScriptEngine;
-import javax.script.ScriptEngineManager;
-import javax.script.ScriptException;
-import javax.script.SimpleScriptContext;
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.MessageBay;
-import org.expeditee.io.flowlayout.XGroupItem;
 import org.expeditee.items.Item;
-import org.expeditee.items.ItemUtils;
 import org.expeditee.items.Text;
 
Index: /trunk/src/org/expeditee/actions/ScriptBase.java
===================================================================
--- /trunk/src/org/expeditee/actions/ScriptBase.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/ScriptBase.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
 import java.util.Collection;
 import java.util.LinkedList;
@@ -32,4 +31,5 @@
 import javax.script.SimpleScriptContext;
 
+import org.expeditee.core.Colour;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
@@ -235,5 +235,5 @@
 	Text errorItem;
 	errorItem = errorFrame.addText(x, y, errorItemLines[cl.line], null);
-	errorItem.setBackgroundColor(Color.RED);
+	errorItem.setBackgroundColor(Colour.RED);
 	for(String line : message.split("[\\n\\r]+")) {
 	    errorItem.setTooltip("text: " + line);
